﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using System.Net.Http.Headers;
using Microsoft.AspNetCore.Hosting;
using System.IO;

namespace UploadboxCoreApi.Controllers
{
    [Route("api/[controller]/[action]")]
    public class UploadboxController : Controller
    {
        private IHostingEnvironment hostingEnv;

        public UploadboxController(IHostingEnvironment env)
        {
            this.hostingEnv = env;
        }

        [HttpPost]
        public async Task<IActionResult> Save(IList<IFormFile> UploadDefault)
        {
            long size = 0;
            foreach (var file in UploadDefault)
            {
                var filename = ContentDispositionHeaderValue
                                .Parse(file.ContentDisposition)
                                .FileName
                                .Trim('"');
                filename = hostingEnv.WebRootPath + $@"\{filename}";
                size += file.Length;
                using (FileStream fs = System.IO.File.Create(filename))
                {
                    await file.CopyToAsync(fs);
                    fs.Flush();
                }
            }
            return Content("");
        }
    }
}
